/** GSWSessionTimeOut.h - <title>GSWeb: Class GSWSessionTimeOut</title>

   Copyright (C) 1999-2002 Free Software Foundation, Inc.
   
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date: 	Mar 1999
   
   $Revision: 17028 $
   $Date: 2003-06-25 10:39:02 -0500 (Wed, 25 Jun 2003) $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

// $Id: GSWSessionTimeOut.h 17028 2003-06-25 15:39:02Z mguesdon $

#ifndef _GSWSessionTimeOut_h__
	#define _GSWSessionTimeOut_h__


//====================================================================
@interface GSWSessionTimeOut : NSObject
{
  NSString* _sessionID;
  NSTimeInterval _lastAccessTime;
  NSTimeInterval _timeOut;
  BOOL _isCheckedOut;
};

-(void)dealloc;
-(id)initWithSessionID:(NSString*)aSessionID
        lastAccessTime:(NSTimeInterval)aTime
        sessionTimeOut:(NSTimeInterval)aTimeOutInterval;
+(id)timeOutWithSessionID:(NSString*)aSessionID
           lastAccessTime:(NSTimeInterval)aTime
           sessionTimeOut:(NSTimeInterval)aTimeOutInterval;
-(NSString*)description;
-(NSComparisonResult)compareTimeOutDate:(GSWSessionTimeOut*)timeOutObject;
-(NSTimeInterval)sessionTimeOut;
-(void)setSessionTimeOut:(NSTimeInterval)aTimeOutInterval;
-(NSString*)sessionID;
-(void)setLastAccessTime:(NSTimeInterval)aTime;
-(NSTimeInterval)lastAccessTime;
-(NSDate*)lastAccessTimeDate;
-(NSTimeInterval)timeOutTime;
-(NSDate*)timeOutTimeDate;
-(BOOL)isCheckedOut;
-(void)setIsCheckedOut:(BOOL)isCheckOut;
@end


#endif // _GSWSessionTimeOut_h__
